function moveblock()
	local moving = findfeature(nil,"is","move")
	local isback = findfeature(nil,"is","back")
	local isshift = findfeature(nil,"is","shift")
	
	if (moving ~= nil) then
		for i,v in ipairs(moving) do
			local these = findall(v)
			
			if (#these > 0) then
				for a,unitid in ipairs(these) do
					local unit = mmf.newObject(unitid)
					local dir = unit.values[DIR]
					
					local isyou = hasfeature(v[1],"is","you",unitid)
					
					if (isyou == nil) and (unit.values[MOVED] == 0) then
						local d = ndirs[dir+1]
						local ox = d[1]
						local oy = d[2]

						local boop = move(unitid,ox,oy)
						
						if (boop == 1) then
							local newdir = rotate(dir)
							
							d = ndirs[newdir+1]
							ox = d[1]
							oy = d[2]
							
							updatedir(unitid,newdir)
							
							if (unit.values[MOVED] == 0) then
								move(unitid,ox,oy,newdir)
							end
						end
					elseif (isyou ~= nil) then
						local d = ndirs[dir+1]
						local ox = d[1]
						local oy = d[2]
						unit.values[PUSHED] = 4

						local boop = move(unitid,ox,oy,dir)
					end
				end
			end
		end
	end
	
	if (isback ~= nil) then
		for i,v in ipairs(isback) do
			local these = findall(v)
			
			if (#these > 0) then
				for a,unitid in ipairs(these) do
					local unit = mmf.newObject(unitid)
					
					unit.values[A] = unit.values[A] + 2
					
					if (undobuffer[unit.values[A]] ~= nil) then
						doback(unit,undobuffer[unit.values[A]])
					end
				end
			end
		end
	end
	
	if (isshift ~= nil) then
		for i,v in ipairs(isshift) do
			local these = findall(v)
			
			if (#these > 0) then
				for a,unitid in ipairs(these) do
					local unit = mmf.newObject(unitid)
					local x,y,dir = unit.values[XPOS],unit.values[YPOS],unit.values[DIR]
					
					local things = findallhere(x,y,unitid)
					
					if (#things > 0) then
						for e,f in ipairs(things) do
							local newunit = mmf.newObject(f)
							local name = newunit.strings[UNITNAME] 
							local hasshift = hasfeature(name,"is","shift")
							
							if (newunit.values[MOVED] == 0) or ((newunit.values[MOVED] == 1) and (newunit.values[DIR] ~= dir) and (hasshift == nil)) then
								if (newunit.strings[UNITTYPE] ~= "text") and (issafe(f) == false) then
									local drs = ndirs[dir+1]
									local ox = drs[1]
									local oy = drs[2]
									
									move(f,ox,oy,dir,true)
								end
							end
							
							if (hasshift ~= nil) and ((unit.values[MOVED] == 0) or ((unit.values[MOVED] == 1) and (newunit.values[DIR] ~= dir))) then
								local drs = ndirs[newunit.values[DIR]+1]
								local ox = drs[1]
								local oy = drs[2] 
								
								move(unitid,ox,oy,newunit.values[DIR],true)
							end
						end
					end
				end
			end
		end
	end
end

function block()
	local delthese = {}
	local unitsnow = #units
	
	for k,unit in ipairs(units) do
		if (k <= unitsnow) then
			local unitrules = {}
			local unitid = unit.fixed
			local name = unit.strings[UNITNAME]
			local x,y,dir,moved,id = unit.values[XPOS],unit.values[YPOS],unit.values[DIR],unit.values[MOVED],unit.values[ID]
			local ox,oy = 0,0
			local online = true
			
			if (unit.strings[UNITTYPE] == "text") then
				name = "text"
			end
			
			if (featureindex[name] ~= nil) then
				for a,b in ipairs(featureindex[name]) do
					if (b[5] == nil) then
						table.insert(unitrules, {b[1],b[2],b[3][1]})
					else
						if ison({name,b[3]},unitid) then
							table.insert(unitrules, b)
						end
					end
				end
	
				local isice = isthis(unitrules,"melt")
				local ismove = isthis(unitrules,"move")
				local isyou = isthis(unitrules,"you")
				local ispush = isthis(unitrules,"push")
				local ispull = isthis(unitrules,"pull")
				local iskill = isthis(unitrules,"kill")
				local iswin = isthis(unitrules,"win")
				local isbest = isthis(unitrules,"best")
				local isgrow = isthis(unitrules,"grow")
				local istele = isthis(unitrules,"tele")
				local isweak = isthis(unitrules,"weak")
				local isshut = isthis(unitrules,"shut")
				local ishide = isthis(unitrules,"hide")
				local isback = isthis(unitrules,"back")
				
				if (isback == false) then
					unit.values[A] = 0
				end
					
				if ispush or ismove or isyou or ispull then
					local sink = findfeature(nil,"is","sink")
					
					if (sink ~= nil) then
						for i,v in ipairs(sink) do
							local water = findtype(v,x,y,0)
							
							if (#water > 0) then
								for a,b in ipairs(water) do
									if (b > 0) and (issafe(unitid) == false) then
										table.insert(delthese, {unitid, 3})
										online = false
										
										if (b ~= unitid) and (issafe(b) == false) then
											table.insert(delthese, {b, 0})
										end
										
										break
									end
								end
							end
						end
					end
				end
				
				if isshut then
					local open = findfeature(nil,"is","open")
					
					if (open ~= nil) then
						for i,v in ipairs(open) do
							local key = findtype(v,x,y,0)
							
							if (#key > 0) then
								for a,b in ipairs(key) do
									if (b > 0) and (issafe(unitid) == false) then
										table.insert(delthese, {unitid, 4})
										online = false
										
										if (b ~= unitid) and (issafe(b) == false) then
											table.insert(delthese, {b, 0})
										end
										
										break
									end
								end
							end
						end
					end
				end
				
				if isweak and (issafe(unitid) == false) then
					local stuff = findallhere(x,y)
					
					if (#stuff > 0) then
						for i,v in ipairs(stuff) do
							local vunit = mmf.newObject(v)
							local thistype = vunit.strings[UNITTYPE]
							if (v ~= unitid) and (thistype ~= "text") then
								table.insert(delthese, {unitid, 4})
								online = false
								break
							end
						end
					end
				end
				
				if isyou and online then
					local win = findfeature(nil,"is","win")
					
					if (win ~= nil) then
						for a,b in ipairs(win) do
							if (b[1] ~= "empty") then
								local weakflag = hasfeature(b[1],"is","weak")
								
								if (weakflag == nil) then
									local flag = findtype(b,x,y,0)
									
									if (#flag > 0) then
										MF_win()
										break
									end
								end
							end
						end
					end
					
					local kill = findfeature(nil,"is","kill")
					local allkill = findfeature("all","is","kill")
					
					if (kill ~= nil) and (allkill == nil) then
						for a,b in ipairs(kill) do
							if (b[1] ~= "empty") then
								local skull = findtype(b,x,y,0)
								
								if (#skull > 0) and (issafe(unitid) == false) then
									table.insert(delthese, {unitid, 5})
								end
							end
						end
					end
				end
				
				if isice then
					local hot = findfeature(nil,"is","hot")
					
					if (hot ~= nil) then
						for a,b in ipairs(hot) do
							local lava = findtype(b,x,y,0)
						
							if (#lava > 0) and (issafe(unitid) == false) then
								table.insert(delthese, {unitid, 5})
								online = false
							end
						end
					end
				end
				
				if iskill then
					local player = findfeature(nil,"is","you")
					
					if (player ~= nil) then
						for i,v in ipairs(player) do
							local skull = findtype(v,x,y,0)
							
							if (#skull > 0) then
								for a,b in ipairs(skull) do
									if (b > 0) and (issafe(b) == false) then
										table.insert(delthese, {b, 5})
									end
								end
							end
						end
					end
				end
				
				if iswin and online then
					local player = findfeature(nil,"is","you")
					
					if (player ~= nil) then
						for a,b in ipairs(player) do
							local flag = findtype(b,x,y,0)
							local ded = hasfeature(b[1],"is","weak")
							
							if (#flag > 0) and (ded == nil) then
								MF_win()
								break
							end
						end
					end
				end
				
				if isgrow then
					for i=1,4 do
						local drs = ndirs[i]
						ox = drs[1]
						oy = drs[2]
						
						local valid = true
						local obs = findobstacle(x+ox,y+oy)
						local tileid = x+ox + (y+oy) * roomsize
						
						if (#obs > 0) then
							for a,b in ipairs(obs) do
								if (b == -1) then
									valid = false
								elseif (b > 0) then
									local bunit = mmf.newObject(b)
									local obsname = bunit.strings[UNITNAME]
									local obstype = bunit.strings[UNITTYPE]
									local obsstop = hasfeature(obsname,"is","stop",b)
									local obspush = hasfeature(obsname,"is","push",b)
									local obspull = hasfeature(obsname,"is","pull",b)
									local obsyou = hasfeature(obsname,"is","you",b)
									
									if (obsstop ~= nil) or (obspush ~= nil) or (obsyou ~= nil) or (obspull ~= nil) or (obsname == name) or (obstype == "text") then
										valid = false
									end
									
									--valid = false
								end
							end
						end
						
						if valid then
							copy(unitid,x+ox,y+oy)
						end
					end
				end
				
				if istele then
					local targets = findallhere(x,y)
					
					if (#targets > 0) then
						for i,v in ipairs(targets) do
							local vunit = mmf.newObject(v)
							local thistype = vunit.strings[UNITTYPE]
							if (issafe(v) == false) and (thistype ~= "text") then
								local targetname = vunit.strings[UNITNAME]
								if (objectdata[v] == nil) then
									objectdata[v] = {}
								end
								
								local odata = objectdata[v]
								
								if (odata.tele == nil) then
									if (targetname ~= name) and (v ~= unitid) then
										local teles = findall({name})
										
										if (#teles > 1) then
											local teletargets = {}
											local targettele = 0
											
											for a,b in ipairs(teles) do
												local tele = mmf.newObject(b)
												
												if (b ~= unit) then
													table.insert(teletargets, b)
												end
											end
											
											if (#teletargets > 0) then
												targettele = teletargets[math.random(#teletargets)]
												local limit = 0
												
												while (targettele == unitid) and (limit < 10) do
													targettele = teletargets[math.random(#teletargets)]
													limit = limit + 1
												end
												
												odata.tele = 1
												
												local tele = mmf.newObject(targettele)
												local tx,ty = tele.values[XPOS],tele.values[YPOS]
											
												update(v,tx,ty)
											end
										end
									end
								end
							end
						end
					end
				end
				
				if isbest then
					MF_bling(unitid)
					addundo({"bling",name,id})
				end
				
				if ishide and unit.visible then
					unit.visible = false
					addundo({"visibility",name,id,0})
				end
			else
				if (unit.visible == false) then
					unit.visible = true
					addundo({"visibility",name,id,1})
				end
				
				unit.values[A] = 0
			end
		else
			break
		end
	end
	
	if (#delthese > 0) then
		for i,v in ipairs(delthese) do
			local uid = v[1]
			if (deleted[uid] == nil) then
				delete(uid,v[2])
				deleted[uid] = 1
			end
		end
	end
end

function emptyisbest()
	local emptyisbest = hasfeature("empty","is","best",0)
	
	if (emptyisbest ~= nil) then
		MF_blingempty()
		addundo({"blingempty"})
	end
end

function doback(unit,actions)
	local id = unit.values[ID]
	
	if (#actions > 0) then
		for i,line in ipairs(actions) do
			local checkid = 0
			local style = line[1]
			
			if (style == "update") then
				checkid = line[9]
			elseif (style == "remove") then
				checkid = line[6]
			elseif (style == "create") then
				checkid = line[3]
			elseif (style == "bling") then
				checkid = line[3]
			elseif (style == "visibility") then
				checkid = line[3]
			end
			
			if (checkid == id) then
				if (style == "update") then
					local oldx,oldy = unit.values[XPOS],unit.values[YPOS]
					local x,y,dir = line[3],line[4],line[5]
					
					local ox = x-oldx
					local oy = y-oldy
					
					if (math.abs(ox) + math.abs(oy) <= 1) then
						local realdir = rotate(dir)
						
						move(unit.fixed,ox,oy,realdir,true)
						unit.values[DIR] = dir
					else
						unit.values[XPOS] = x
						unit.values[YPOS] = y
						unit.values[DIR] = dir
						unit.values[POSITIONING] = 0
					end
					
					updateunitmap(unitid,oldx,oldy,x,y)
					dynamic(unitid)
					dynamicat(oldx,oldy)
					
					if (unit.strings[UNITTYPE] == "text") then
						updatecode = 1
					end
				elseif (style == "remove") then
					local x,y,dir = line[3],line[4],line[5]
					local name = line[2]
					local newunitid = MF_emptycreate(name,x,y)
					
					local newunit = mmf.newObject(newunitid)
					newunit.values[ONLINE] = 1
					newunit.values[XPOS] = x
					newunit.values[YPOS] = y
					newunit.values[DIR] = dir
					newunit.values[ID] = line[6]
					newunit.flags[9] = true
					
					addunit(newunitid)
					addunitmap(newunitid,x,y)
					dynamic(newunitid)
					
					if (newunit.strings[UNITTYPE] == "text") then
						updatecode = 1
					end
				elseif (style == "create") then
					local x,y = unit.values[XPOS],unit.values[YPOS]
					local unittype = unit.strings[UNITTYPE]

					delunit(unit.fixed)
					MF_remove(unit.fixed,0)
					dynamicat(x,y)
					
					if (unittype == "text") then
						updatecode = 1
					end
				elseif (style == "bling") then
					MF_bling(unit.fixed)
				elseif (style == "visibility") then
					if (line[4] == 0) then
						unit.visible = true
					elseif (line[4] == 1) then
						unit.visible = false
					end
				end 
			end
		end
	end
end

function startblock()
	for i,unit in ipairs(units) do
		local name = unit.strings[UNITNAME]
		local unitrules = {}
		
		if (unit.strings[UNITTYPE] == "text") then
			name = "text"
		end
		
		if (featureindex[name] ~= nil) then
			for a,b in ipairs(featureindex[name]) do
				if (b[5] == nil) then
					table.insert(unitrules, {b[1],b[2],b[3][1]})
				else
					if ison({name,b[3]},unitid) then
						table.insert(unitrules, b)
					end
				end
			end
			
			local ishide = isthis(unitrules, "hide")
			
			if ishide then
				if ishide and unit.visible then
					unit.visible = false
				end
			end
		end
	end
end

function keyblock(data)
	for i,v in ipairs(data) do
		if (#v == 3) then
			local action = v[3][1]
			
			if (action == "win") then
				MF_win()
			elseif (action == "kill") then
				local yous = findfeature(nil,"is","you")
				
				if (yous ~= nil) then
					for a,b in ipairs(yous) do
						local allyous = findall(b)
						
						if (#allyous > 0) then
							for c,d in ipairs(allyous) do
								delete(d,2)
							end
						end
					end
				end
			end
		end
	end
end