function newundo()
	table.insert(undobuffer, 1, {})
end

function addundo(line)
	local currentundo = undobuffer[1]
	local text = tostring(#undobuffer) .. ", "
	
	table.insert(currentundo, 1, {})
	currentundo[1] = {}
	
	for i,v in ipairs(line) do
		table.insert(currentundo[1], v)
		text = text .. tostring(v) .. " "
	end
	
	--print(text)
end


function undo()
	if (#undobuffer > 1) then
		local currentundo = undobuffer[2]
		
		if (currentundo ~= nil) then
			for i,line in ipairs(currentundo) do
				local style = line[1]
				
				if (style == "update") then
					local unitid = getunitid(line[9])
					local unit = mmf.newObject(unitid)
					
					local oldx,oldy = unit.values[XPOS],unit.values[YPOS]
					local x,y,dir = line[3],line[4],line[5]
					unit.values[XPOS] = x
					unit.values[YPOS] = y
					unit.values[DIR] = dir
					unit.values[POSITIONING] = 0
					
					updateunitmap(unitid,oldx,oldy,x,y)
					dynamic(unitid)
					dynamicat(oldx,oldy)
					
					local ox = math.abs(oldx-x)
					local oy = math.abs(oldy-y)
					
					if (ox + oy == 1) and (unit.values[TILING] == 2) then
						unit.values[VISUALDIR] = ((unit.values[VISUALDIR] - 1)+4) % 4
						unit.direction = unit.values[DIR] * 8 + unit.values[VISUALDIR]
					end
					
					if (unit.strings[UNITTYPE] == "text") then
						updatecode = 1
					end
				elseif (style == "remove") then
					local x,y,dir = line[3],line[4],line[5]
					local name = line[2]
					local unitid = MF_emptycreate(name,x,y)
					
					local unit = mmf.newObject(unitid)
					unit.values[ONLINE] = 1
					unit.values[XPOS] = x
					unit.values[YPOS] = y
					unit.values[DIR] = dir
					unit.values[ID] = line[6]
					unit.flags[9] = true
					
					addunit(unitid)
					addunitmap(unitid,x,y)
					dynamic(unitid)
					
					if (unit.strings[UNITTYPE] == "text") then
						updatecode = 1
					end
				elseif (style == "create") then
					local unitid = getunitid(line[3])
					local unit = mmf.newObject(unitid)
					local x,y = unit.values[XPOS],unit.values[YPOS]
					local unittype = unit.strings[UNITTYPE]
					
					unit = {}
					delunit(unitid)
					MF_remove(unitid,0)
					dynamicat(x,y)
					
					if (unittype == "text") then
						updatecode = 1
					end
				elseif (style == "bling") then
					local unitid = getunitid(line[3])
					MF_bling(unitid)
				elseif (style == "blingempty") then
					MF_blingempty()
				elseif (style == "visibility") then
					local unitid = getunitid(line[3])
					local unit = mmf.newObject(unitid)
					if (line[4] == 0) then
						unit.visible = true
					elseif (line[4] == 1) then
						unit.visible = false
					end
				end
			end
		end
		
		table.remove(undobuffer, 2)
	end
end